;********************************************************************
;           Mangement of the CD Routines  
;
;     - Check The initial Cd Status
;     - Read TOC
;     - Detect if CD-DA or CD-Mp3
;     - Get Total Songs number
;     - Table info of Songs in Ram (position in cd,name,legth,etc)
;
; Ver 1.0                              Coded By Leandro Gentili /1999   
;********************************************************************	                         

SENSE
              call REQUEST_SENSE

              movlw 0x00
              subwf TEMP2,w
              btfsc STATUS,Z
              return 

              movlw 0x28
              subwf TEMP2,w
              btfsc STATUS,Z
              return

              movlw 0x29
              subwf TEMP2,w
              btfsc STATUS,Z
              return                                      

              movlw 0x3A
              subwf TEMP2,w
              bcf FLAG_CD,4
              btfss STATUS,Z
              return

              bsf FLAG_CD,4
              goto MOSTRA
              return
;************
INI_CD   
              clrf FLAG_CD
              clrf TOTAL_SONG

              call SENSE                 
              call ESPERA

              call SENSE                 
              call ESPERA
 
HASTA_NOERROR              
              call READ_TOC
              btfss STATUS_R,ERR
              goto DALE 
              call SENSE
              btfsc FLAG_CD,4
              return
              goto HASTA_NOERROR                        
;************
DALE
              call RD_DATA_R      ; decremento 2 datos del TOC 
              movf DATA_RH,w        
              movwf COUNTER
              decf COUNTER
              decf COUNTER                   

              call RD_DATA_R      ;  2 datos que no sirven
              movlw 0x00
              movwf ADR_WL
              movlw 0x40
              movwf ADR_WH
              movlw .1
              movwf COUNTER2
DIFICIL              
              incfsz ADR_WL
              goto KA0
              incf ADR_WH 
;************
KA0                               ; Me Fijo si es ROM o DA 
              call RD_DATA_R
              movf DATA_RH,w
              andlw b'00000100'
              btfss STATUS,Z
              goto CDROM
              bsf MESSAJE,2
              bsf FLAG_CD,6
              goto VENDA
CDROM
              bsf MESSAJE,3
              bsf FLAG_CD,5
VENDA                  
              call RD_DATA_R
;************         
              call RD_DATA_R      ; Pongo MSF en la RAM 
              movf DATA_RH,w
              movwf BYTERAM
              call WR_RAM
         
              call RD_DATA_R       
              incfsz ADR_WL
              goto KA1
              incf ADR_WH 
KA1
              movf DATA_RL,w
              movwf BYTERAM
              call WR_RAM
   
              incfsz ADR_WL
              goto KA2
              incf ADR_WH 
KA2
              movf DATA_RH,w
              movwf BYTERAM
              call WR_RAM
;************   
              movlw .16
              movwf COUNTER1            ; Pongo 16 espacios 
              movlw 0x20
              movwf BYTERAM
DALE2B
              incfsz ADR_WL
              goto KA6B
              incf ADR_WH
KA6B
              call WR_RAM
              decfsz COUNTER1
              goto DALE2B
;************
              incfsz ADR_WL
              goto KA3
              incf ADR_WH 
KA3                      
              movlw M_TRACK-BASE2      ; Pongo "TRACK" en RAM
              movwf COUNTER1
MAMO
              movlw .8
              movwf PCLATH
              movf COUNTER1,w
              call MORO
              clrf PCLATH

              movwf BYTERAM             
              call WR_RAM        

              incfsz ADR_WL
              goto KA4
              incf ADR_WH        
KA4              
              incf COUNTER1
              movlw M_NUM-BASE2
              subwf COUNTER1,w
              btfss STATUS,Z
              goto MAMO         
;************
              movlw 0x20
              movwf BYTERAM
              call WR_RAM

              incfsz ADR_WL
              goto KA77
              incf ADR_WH        
KA77      
              movf COUNTER2,w          ; Pongo el NUMERO del Track (XX)  
              movwf L_BYTE
              call BCD

              movf DIG_2,w
              movwf BYTERAM

              call WR_RAM

              incfsz ADR_WL
              goto KA5
              incf ADR_WH        
KA5
              movf DIG_1,w
              movwf BYTERAM 
              call WR_RAM
;************
              movlw .8
              movwf COUNTER1      ; Pongo 8 espacios 
              movlw 0x20
              movwf BYTERAM
DALE2
              incfsz ADR_WL
              goto KA6
              incf ADR_WH
KA6
              call WR_RAM
              decfsz COUNTER1
              goto DALE2                                     
;************          
              movlw .29           ; Dejo la Ram apuntando a la Proxima Cancion  
              addwf ADR_WL
              btfsc STATUS,C
              incf ADR_WH      
              incf COUNTER2
;************
              incf TOTAL_SONG

              movlw .8            ; Delecremento en 8 el contador del TOC 
              subwf COUNTER        
              btfss STATUS,Z
              goto DIFICIL      

              decf TOTAL_SONG
              btfss FLAG_CD,6     ; es DA,ROM or Hybrid?
              goto DATA_CD
              btfss FLAG_CD,5
              goto MOSTRA

              clrf MESSAJE
              bsf MESSAJE,4       ; Hybrid 
              goto MOSTRA                                            
              
MOSTRA              
              movlw .8
              movwf PCLATH
              call MENSAJE_L1     ; DA
              clrf PCLATH

              call ESPERA
              call ESPERA
              call ESPERA 
              call ESPERA
              call ESPERA
              call ESPERA
              call ESPERA
              call ESPERA
              call ESPERA
              return
;***********************************************************
;*********************************************************** 
DATA_CD                     
              clrf TOTAL_SONG 

              call MOSTRA
            
              movlw 0x00
              movwf BYTERAM 
              call FULL_BUFFERXX

              call TEST_JOULIET          
            
              call TABLA_INFO 

              return

;***********************************************************
;*********************************************************** 
TEST_JOULIET
              movlw 0x08
              movwf TOPE
              movlw 0x01
              movwf TRANS_1            
              clrf TRANS_2
              clrf LBA_4
              clrf LBA_3
              clrf LBA_2

              movlw .16
              movwf LBA_1
              call READ10
              call RD_STATUS_A
              call ST2
              call FULL_BUFFER
              call TEST

              btfsc FLAG,JOULIET
              return

              incf LBA_1
              call READ10
              call RD_STATUS_A
              call ST2
              call FULL_BUFFER
              call TEST
 
              btfsc FLAG,JOULIET
              return 
        
              incf LBA_1
              call READ10
              call RD_STATUS_A
              call ST2
              call FULL_BUFFER
              call TEST 

              btfsc FLAG,JOULIET
              return
              movlw .16
              movwf LBA_1
              call READ10
              call RD_STATUS_A
              call ST2

              call FULL_BUFFER
              return
TEST
              clrf ADR_RL
              clrf ADR_RH
              
GENTILI               
              call RD_RAM
              movlw .8
              movwf PCLATH

              movf ADR_RL,w              
              addlw M_ID-BASE2
              call MORO
              clrf PCLATH
              subwf BYTERAM,w
              btfss STATUS,Z
              goto NO_JOULIET
              incf ADR_RL
              movlw 0x06
              subwf ADR_RL,w
              btfsc STATUS,Z
              goto SI_JOULIET
              goto  GENTILI

NO_JOULIET 
              bcf FLAG,JOULIET              
              return
SI_JOULIET
              bsf FLAG,JOULIET
              return          
;***********************************************************
;***********************************************************             
TABLA_INFO                       
              movlw .140 
              movwf ADR_RL
              clrf ADR_RH              

              call RD_RAM            ; 141-144 direccion PT
              movf BYTERAM,w
              movwf LBA_1            ; Leo LBA del Path Table 
              call READ10             
              call RD_STATUS_A
              call ST2

              call FULL_BUFFER
          
              movlw 0x02
              movwf ADR_RL
              clrf ADR_RH 

              call RD_RAM            ; 3-6 Location Directory Record (root)  
              movf BYTERAM,w
              movwf LBA_1
              incf ADR_RL
              call RD_RAM
              movf BYTERAM,w
              movwf LBA_2

              incf ADR_RL
              call RD_RAM           
              movf BYTERAM,w
              movwf LBA_3
              incf ADR_RL
              call RD_RAM
              movf BYTERAM,w
              movwf LBA_4

              call READ10
              call RD_STATUS_A
              call ST2

              call FULL_BUFFER
          
              movlw .11          ; 11-18 Cantidad de Bytes del Root 
              movwf ADR_RL
              clrf ADR_RH                      
              call RD_RAM
              movf BYTERAM,w
              movwf COUNTER2
              
              bcf STATUS,C
              rrf COUNTER2
              bcf STATUS,C
              rrf COUNTER2
              bcf STATUS,C
              rrf COUNTER2               

              movf COUNTER2,w     ; If counter = 0 lo pones en 1 
              sublw 0x00
              btfsc STATUS,Z
              incf COUNTER2

              clrf ADR_RL          
              clrf ADR_RH

              movlw 0x00
              movwf ADR_WL
              movlw 0x40
              movwf ADR_WH
                    
              call RD_RAM         ; Apunto AL primer MP3
              movf BYTERAM,w
              addwf ADR_RL

              call RD_RAM
              movf BYTERAM,w
              addwf ADR_RL          
;*****
QUIEROMAS
              movf ADR_RL,w
              movwf TEMP1
              movf ADR_RH,w
              movwf TEMP2
              movf ADR_WL,w 
              movwf TEMP4 
              movf ADR_WH,w 
              movwf TEMP5          
GRAN_LOOPY
              call RD_RAM         ; Termino ? (=00)?
              movf BYTERAM,w
              movwf TEMP3
              sublw 0x00
              btfsc STATUS,Z
              goto FIN

              movlw .32           ; Pongo Todos (32)   en las posiciones del nombre (RAM)
              movwf COUNTER1
              movlw 0x20
              movwf BYTERAM                  

              movlw .9
              addwf ADR_WL
              btfsc STATUS,C
              incf ADR_WH
MAM              
              call WR_RAM              

              incfsz ADR_WL   
              goto BA8
              incf ADR_WH
BA8                                       
              decfsz COUNTER1            
              goto MAM
              
              movlw .40           ; Apunto Al Position LBA
              subwf ADR_WL
              btfss STATUS,C
              decf ADR_WH      

              movlw .2
              addwf ADR_RL
              btfsc STATUS,C
              incf ADR_RH                    
;********
              movlw 0x04
              movwf COUNTER         
TOTO
              call RD_RAM 
              call WR_RAM

              incfsz ADR_RL
              goto BA1
              incf ADR_RH
BA1
              incfsz ADR_WL
              goto BA2
              incf ADR_WH
BA2
              decfsz COUNTER          
              goto TOTO
;********         
              movlw .4
              addwf ADR_RL
              btfsc STATUS,C
              incf ADR_RH
           
              movlw 0x04
              movwf COUNTER
              movlw BASEF
              movwf FSR 
TOTO1
              call RD_RAM             
              movf BYTERAM,w
              movwf INDF          

              incfsz ADR_RL
              goto BA3
              incf ADR_RH
BA3
              incf FSR
              decfsz COUNTER          
              goto TOTO1           
;*********
              movf BASEF,w
              sublw 0x00
              btfss STATUS,Z
              goto UNOMAS
              movf BASEF+1,w
              andlw b'00000111'
              btfss STATUS,Z
              goto UNOMAS
              goto ROLA
UNOMAS
              movlw 0x08
              addwf BASEF+1
              btfss STATUS,C
              goto ROLA
              incfsz BASEF+2
              goto ROLA
              incf BASEF+3
ROLA                           
              clrf BASEF              
;********                                
              movlw 0x04
              movwf COUNTER
              movlw BASEF
              movwf FSR
TOTO2                        
              movf INDF,w
              movwf BYTERAM
              call WR_RAM

              incfsz ADR_WL
              goto BA4
              incf ADR_WH
BA4
              incf FSR
              decfsz COUNTER          
              goto TOTO2        
;*********
              movlw .18           ; Apunto Al largo del nombre
              addwf ADR_RL
              btfsc STATUS,C
              incf ADR_RH

              movlw .16
              movwf COUNTER        
OTTO
              btfss FLAG,JOULIET
              goto N_JOU1
                
              incfsz ADR_RL   
              goto BA5
              incf ADR_RH
BA5
              call RD_RAM
N_JOU1
              incfsz ADR_RL   
              goto BA6
              incf ADR_RH
BA6       
              call RD_RAM
              movf BYTERAM,w

              sublw 0x2D          ; Separador -   
              btfsc STATUS,Z
              goto TERMINB

              movf COUNTER,w
              sublw 0x00
              btfsc STATUS,Z
              goto OTTO   

              call WR_RAM           

              incfsz ADR_WL   
              goto BA7
              incf ADR_WH
BA7
              decf COUNTER
              goto OTTO             
;*********                      
TERMINB              
              movf COUNTER,w
              addwf ADR_WL
              btfsc STATUS,C
              incf ADR_WH

              movlw .16
              movwf COUNTER        
OTTOB
              btfss FLAG,JOULIET
              goto N_JOU1B
                
              incfsz ADR_RL   
              goto BA5B
              incf ADR_RH
BA5B
              call RD_RAM
N_JOU1B
              incfsz ADR_RL   
              goto BA6B
              incf ADR_RH
BA6B       
              call RD_RAM
              movf BYTERAM,w

              sublw 0x2E          ; Separador .   
              btfsc STATUS,Z
              goto TERMIN

              movf COUNTER,w
              sublw 0x00
              btfsc STATUS,Z
              goto OTTOB

              call WR_RAM           

              incfsz ADR_WL   
              goto BA7B
              incf ADR_WH
BA7B
              decf COUNTER
              goto OTTOB
;*********
TERMIN
              movf TEMP3,w
              addwf TEMP1
              btfsc STATUS,C
              incf TEMP2
              movf TEMP1,w
              movwf ADR_RL
              movf TEMP2,w
              movwf ADR_RH

              movlw .64
              addwf TEMP4
              btfsc STATUS,C
              incf TEMP5
              movf TEMP4,w
              movwf ADR_WL
              movf TEMP5,w
              movwf ADR_WH 

              incf TOTAL_SONG                  
              goto GRAN_LOOPY             
FIN           
              decfsz COUNTER2
              goto MAASS
              return    
MAASS
              movf ADR_WL,w
              movwf TEMP1 
              movf ADR_WH,w
              movwf TEMP2

              incfsz LBA_1
              goto LELA
              incfsz LBA_2
              goto LELA
              incfsz LBA_3
              goto LELA
              incf LBA_4
LELA
              call READ10
              call RD_STATUS_A
              call ST2

              call FULL_BUFFER                           
   
              clrf ADR_RL
              clrf ADR_RH      

              movf TEMP1,w
              movwf ADR_WL
              movf TEMP2,w 
              movwf ADR_WH
              
              call RD_RAM         ; Termino ? (=00)?
              movf BYTERAM,w
              movwf TEMP3 
              sublw 0x00
              btfss STATUS,Z
              goto QUIEROMAS
              return                



