;********************************************************************
;             Low and High Level LCD Routine
;        
;         - Ini LCD
;         - Clear row 1 or 2
;         - Put Text in row 1 or 2 
;         - and more
;
; Ver 1.0                              Coded by Leandro Gentili /1999   
;********************************************************************         
CLEAR_D
              movlw 0x01
	      goto COMANDO
RETURN_H 
              movlw 0x02
	      goto COMANDO
MODE_SET	
              movlw 0x04
              goto COMANDO	
DISPLAY_C	
              movlw 0x08
	      goto COMANDO
SHIFT	        
              movlw 0x10
              goto COMANDO
FUNC_SET  	
              movlw 0x20
	      goto COMANDO
SET_CG_AD       
              movlw 0x40 
	      goto COMANDO
SET_DD_AD	 
              movlw 0x80
;**********************************************************
;**********************************************************
COMANDO
              bsf STATUS,RP0
              clrf TRISC
              bcf STATUS,RP0 
    
              iorwf REG_LCD,w
              movwf PORTC
	      bcf PORTB,RSn
	      bcf PORTB,RWn                  

	      goto SEND2LCD
;**********************************************************
;**********************************************************
WRITE_DATA        
              bsf STATUS,RP0
              clrf TRISC
              bcf STATUS,RP0
                  
              movwf PORTC
              bsf PORTB,RSn
              bcf PORTB,RWn
;**********************************************************
;**********************************************************
SEND2LCD
              nop
              nop    
   	      movlw E_LCD
              movwf PORTE
              nop
              nop    
              nop
              clrf PORTE	
	      return
;**********************************************************
;**********************************************************                               
INI_LCD
              movlw b'00010000'
              movwf REG_LCD
              call FUNC_SET

              call ESPERA2
              call ESPERA2

              movlw b'00010000'
              movwf REG_LCD
              call FUNC_SET

              call ESPERA2
              call ESPERA2

              movlw b'00010000'
              movwf REG_LCD
              call FUNC_SET

              call ESPERA2                  

              movlw b'00011000'
              movwf REG_LCD
              call FUNC_SET

              call ESPERA2

              movlw b'00000100'
              movwf REG_LCD
              call DISPLAY_C
                  
              call ESPERA2
 
              clrf REG_LCD
              call CLEAR_D

              call ESPERA2

              movlw b'00000010'
              movwf REG_LCD
              call MODE_SET

              call ESPERA2                                 
                  
	      return 
;**********************************************************
;**********************************************************
MENSAJE_L1      
              clrf REG_LCD
              call SET_DD_AD
              call ESPERA3    
              goto SALTA
MENSAJE_L2
              movlw 0x40
              movwf REG_LCD
              call SET_DD_AD
              call ESPERA3
SALTA
              clrf COUNTER
DALENOMA                  
              movf COUNTER,w 
              call MANDA
              call WRITE_DATA
              call ESPERA3
              incf COUNTER 
              movf COUNTER,w
              sublw .16
              btfss STATUS,Z
              goto DALENOMA
              clrf MESSAJE
              clrf MESSAJE1 
              return
MANDA                   
              btfsc MESSAJE,0
              addlw M_0-BASE2
              btfsc FLAG_CD,4
              addlw M_1-BASE2
              btfsc MESSAJE,2
              addlw M_2-BASE2
              btfsc MESSAJE,3
              addlw M_3-BASE2
              btfsc MESSAJE,4
              addlw M_4-BASE2
              btfsc MESSAJE,5
              addlw M_5-BASE2
              btfsc MESSAJE,6
              addlw M_6-BASE2
              btfsc MESSAJE,7
              addlw M_7-BASE2     
              btfsc MESSAJE1,0
              addlw M_8-BASE2
              btfsc MESSAJE1,1
              addlw M_9-BASE2 
              btfsc FLAG,ATAPIn
              addlw M_10-BASE2  
              btfsc MESSAJE1,2
              addlw M_11-BASE2
MORO                 
              movwf TEMPW
              movlw 0x0F
              movwf PCLATH  
              movf TEMPW,w
              movwf PCL
;**********************************************************
;**********************************************************                    
NO_CURSOR_L2
              movlw 0x40
              movwf REG_LCD
              call SET_DD_AD
              call ESPERA3

              movlw b'00000100'
              movwf REG_LCD
              call DISPLAY_C
              call ESPERA3
              return
;**********************************************************
;**********************************************************
CURSOR_L2         
              movlw 0x40
              movwf REG_LCD
              call SET_DD_AD
              call ESPERA3
                 
              movlw b'00000111'
              movwf REG_LCD
              call DISPLAY_C
              call ESPERA3
              return
;**********************************************************
;**********************************************************
NAME              
              movf ADR_RL,w
              movwf BP0
              movf ADR_RH,w
              movwf BP1
              movf ADR_WL,w
              movwf BP2
              movf ADR_WH,w
              movwf BP3

              clrf REG_LCD
              call SET_DD_AD
              call ESPERA3

              clrf PCLATH
              call CAL_BASE
              movlw .8
              movwf PCLATH
              movlw .2
              movwf COUNTER1

              btfsc FLAG_CD,5
              goto T_CDROM  
              clrf PCLATH
              call CAL_DEST_DA 
              movlw .8
              movwf PCLATH
              goto ELA 
T_CDROM
              clrf PCLATH
              call CAL_DEST_CDROM
              movlw .8
              movwf PCLATH
ELA                  
              movlw .16
              movwf COUNTER
KAKA                
              clrf PCLATH
              call RD_RAM                 
              movlw .8
              movwf PCLATH
              movf BYTERAM,w
              call WRITE_DATA
              call ESPERA3

              incfsz ADR_RL
              goto MONGO
              incf ADR_RH
MONGO
              decfsz COUNTER  
              goto KAKA
              decfsz COUNTER1
              goto LINEA2             

              btfsc FLAG_STATE,MODE
              goto SALTAMOS
              clrf PCLATH
              call CAL_BASE
              call RD_RAM
              movlw .8
              movwf PCLATH                                    

              movf BYTERAM,w
              sublw 0x00
              btfss STATUS,Z
              call CURSOR_L2
SALTAMOS
              movf BP0,w
              movwf ADR_RL 
              movf BP1,w
              movwf ADR_RH
              movf BP2,w
              movwf ADR_WL 
              movf BP3,w
              movwf ADR_WH
              return
LINEA2
              call NO_CURSOR_L2
              goto ELA                                
;**********************************************************
;**********************************************************
NUMERO_SONG
              bsf MESSAJE,5    
              call MENSAJE_L2                  
                  
              movlw 0x4D
              movwf REG_LCD
              call SET_DD_AD
              call ESPERA3

              movf TOTAL_SONG,w 
              call BCD2LCD

              call ESPERA2         ; I had to give u some Code for Optimizate :)
              call ESPERA2
              call ESPERA2
              call ESPERA2
              call ESPERA2
              call ESPERA2
              call ESPERA2
              call ESPERA2
              call ESPERA2
              call ESPERA2
              call ESPERA2
              call ESPERA2
              call ESPERA2
              call ESPERA2
              call ESPERA2
              call ESPERA2
              call ESPERA2
              call ESPERA2
              call ESPERA2
              call ESPERA2
              return
;**********************************************************
;**********************************************************
MOSTRAR_CONTROL
              btfsc FLAG_CD,5        
              goto LENTO 
              movlw .230
              movwf CONT2
              clrf CONT1
              goto SLENTO
LENTO
              movlw .150
              movwf CONT1
              movlw .253
              movwf CONT2
SLENTO
              btfsc FLAG_CD,5
              goto DOS2
              movf CONTROL,w
              sublw .2
              btfsc STATUS,Z
              goto TRACK_MENU
DOS2
              movf CONTROL,w           
              sublw .4
              btfsc STATUS,Z
              goto TRACK_MENU
      
              movf CONTROL,w
              sublw .1
              btfsc STATUS,Z
              goto VOLUMEN_MENU

              movf CONTROL,w
              sublw .2
              btfsc STATUS,Z
              goto BASS_MENU                      
 
              call T_TEXT
              return
VOLUMEN_MENU
              call V_TEXT
              return
BASS_MENU
              call B_TEXT
              return
TRACK_MENU
              clrf CONTROL
              call NAME
              bcf FLAG_STATE,MODE
              return     
;**********************************************************
;**********************************************************
V_TEXT
              bsf MESSAJE,6
              call MENSAJE_L1 
     
              bsf MESSAJE1,1
              call MENSAJE_L2

              movlw 0x46
              movwf REG_LCD
              call SET_DD_AD
              call ESPERA3

              movf VOLUMEN,w
              call BCD2LCD1

              return
;**********************************************************
;**********************************************************          
B_TEXT
              bsf MESSAJE,7
              call MENSAJE_L1 
               
              bsf MESSAJE1,1
              call MENSAJE_L2
              call ESPERA3

              movlw 0x45
              movwf REG_LCD
              call SET_DD_AD
              call ESPERA3

     
              movlw .8
              subwf BASS,w
              movwf TEMPW        
      
              btfss STATUS,C
              goto NEGA                   
           
              movlw .43
              call WRITE_DATA
              call ESPERA3 

              movf TEMPW,w

              call BCD2LCD1
              return
NEGA              
              movlw .45
              call WRITE_DATA
              call ESPERA3 

              comf TEMPW
              incf TEMPW,w

              call BCD2LCD1
              return
;**********************************************************
;**********************************************************          
T_TEXT
              bsf MESSAJE1,0
              call MENSAJE_L1 
               
              bsf MESSAJE1,1
              call MENSAJE_L2
              call ESPERA3

              movlw 0x45
              movwf REG_LCD
              call SET_DD_AD
              call ESPERA3
    
              movlw .8
              subwf TREBLE,w
              movwf TEMPW        
      
              btfss STATUS,C
              goto NEGA1                   
           
              movlw .43
              call WRITE_DATA
              call ESPERA3 

              movf TEMPW,w

              call BCD2LCD1
              return
NEGA1              
              movlw .45
              call WRITE_DATA
              call ESPERA3 

              comf TEMPW
              incf TEMPW,w

              call BCD2LCD1
              return
;**********************************************************
;**********************************************************
BCD2LCD
              movwf L_BYTE
              clrf PCLATH
              call BCD
              movlw .8
              movwf PCLATH

              movf DIG_3,w
              call WRITE_DATA
              call ESPERA3
              movf DIG_2,w
              call WRITE_DATA
              call ESPERA3 
              movf DIG_1,w
              call WRITE_DATA
              call ESPERA3

              return
;**********************************************************
;**********************************************************
BCD2LCD1
              movwf L_BYTE
              clrf PCLATH
              call BCD
              movlw .8
              movwf PCLATH

              movf DIG_2,w
              call WRITE_DATA
              call ESPERA3 
              movf DIG_1,w
              call WRITE_DATA
              call ESPERA3

              return
;**********************************************************
;**********************************************************

;**********************************************************
;        DeLaYs
;**********************************************************                          
ESPERA2   
              movlw .255
              movwf ACC1
              movwf ACC2
              goto L2
ESPERA3   
              movlw .1        
              movwf ACC2
              movlw .1
              movwf ACC2
L2                      
              nop                 ; Aprox. 1 MicroSec.
              nop
              decfsz ACC1
              goto L2
              decfsz ACC2
              goto L2
              return
;**********************************************************         
;**********************************************************
